﻿using System;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Microsoft.Office.Core;
using IRibbonControl = AddinExpress.MSO.IRibbonControl;
using MSProject = Microsoft.Office.Interop.MSProject;

namespace ADXMSProject
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("5B849D3A-758A-409D-858B-D63817358AC0"), ProgId("ADXMSProject.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton adxRibbonButton1;
        private ADXProjectAppEvents adxProjectEvents;
        private ADXRibbonButton addViewRibbonButton;
        private ADXRibbonButton filterDataRibbonButton;
        private ADXRibbonGroup adxRibbonGroup2;
        private ADXRibbonSeparator adxRibbonSeparator1;
        private ADXRibbonButton addResourceRibbonButton;
        private ADXRibbonButton editResourceRibbonButton;
        private ADXRibbonSeparator adxRibbonSeparator2;
        private ADXRibbonButton addSummaryTaskRibbonButton;
        private ADXRibbonButton addTaskRibbonButton;
        private ADXRibbonButton editTaskRibbonButton;
        private ADXRibbonGroup adxRibbonGroup3;
        private ADXRibbonButton setCalendarRibbonButton;
        private ADXRibbonGroup adxRibbonGroup4;
        private ADXRibbonButton createReportRibbonButton;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonButton1 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonSeparator1 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.addResourceRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.editResourceRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonSeparator2 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.addSummaryTaskRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.addTaskRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.editTaskRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonGroup3 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.setCalendarRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonGroup4 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.createReportRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonGroup2 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.addViewRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.filterDataRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxProjectEvents = new AddinExpress.MSO.ADXProjectAppEvents(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Add-in Express";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup3);
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup4);
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup2);
            this.adxRibbonTab1.Id = "adxRibbonTab_26f563b677774580970f67d6c111cd89";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Tasks && Resources";
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonButton1);
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonSeparator1);
            this.adxRibbonGroup1.Controls.Add(this.addResourceRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.editResourceRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonSeparator2);
            this.adxRibbonGroup1.Controls.Add(this.addSummaryTaskRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.addTaskRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.editTaskRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_64c6180d64244b17b8fe370bb5395247";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // adxRibbonButton1
            // 
            this.adxRibbonButton1.Caption = "Iterate Selected Project Tasks && Resources";
            this.adxRibbonButton1.Id = "adxRibbonButton_f80b07f026144ce9b75877039795a6bf";
            this.adxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.adxRibbonButton1.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxRibbonButton1.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRibbonButton1_OnClick);
            // 
            // adxRibbonSeparator1
            // 
            this.adxRibbonSeparator1.Id = "adxRibbonSeparator_f8ad24b4e4894d54b0a76ba37d94b4bf";
            this.adxRibbonSeparator1.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // addResourceRibbonButton
            // 
            this.addResourceRibbonButton.Caption = "Add New Resource";
            this.addResourceRibbonButton.Id = "adxRibbonButton_b49406eec2dc4dd5883484587536954c";
            this.addResourceRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.addResourceRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.addResourceRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.addResourceRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.addResourceRibbonButton_OnClick);
            // 
            // editResourceRibbonButton
            // 
            this.editResourceRibbonButton.Caption = "Edit Resource";
            this.editResourceRibbonButton.Id = "adxRibbonButton_396e8227a6e8453f9556ab54a840ad47";
            this.editResourceRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.editResourceRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.editResourceRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.editResourceRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.editResourceRibbonButton_OnClick);
            // 
            // adxRibbonSeparator2
            // 
            this.adxRibbonSeparator2.Id = "adxRibbonSeparator_2987dd42233d4364913d24e793bfe513";
            this.adxRibbonSeparator2.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // addSummaryTaskRibbonButton
            // 
            this.addSummaryTaskRibbonButton.Caption = "Add Summary Task";
            this.addSummaryTaskRibbonButton.Id = "adxRibbonButton_961806a8ae24423b83523d75cd9b1e44";
            this.addSummaryTaskRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.addSummaryTaskRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.addSummaryTaskRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.addSummaryTaskRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.addSummaryTaskRibbonButton_OnClick);
            // 
            // addTaskRibbonButton
            // 
            this.addTaskRibbonButton.Caption = "Add Task";
            this.addTaskRibbonButton.Id = "adxRibbonButton_dfc5f27a54d643d6952f7491ca839553";
            this.addTaskRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.addTaskRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.addTaskRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.addTaskRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.addTaskRibbonButton_OnClick);
            // 
            // editTaskRibbonButton
            // 
            this.editTaskRibbonButton.Caption = "Edit Task";
            this.editTaskRibbonButton.Id = "adxRibbonButton_7340363d08d347bab1987a31dd31281d";
            this.editTaskRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.editTaskRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.editTaskRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.editTaskRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.editTaskRibbonButton_OnClick);
            // 
            // adxRibbonGroup3
            // 
            this.adxRibbonGroup3.Caption = "Calendar";
            this.adxRibbonGroup3.Controls.Add(this.setCalendarRibbonButton);
            this.adxRibbonGroup3.Id = "adxRibbonGroup_e33a5e74864c432facf900e0d436ce33";
            this.adxRibbonGroup3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup3.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // setCalendarRibbonButton
            // 
            this.setCalendarRibbonButton.Caption = "Set Calendar Workdays/Shifts";
            this.setCalendarRibbonButton.Id = "adxRibbonButton_c8430a5be08a43fbb2f61627de065611";
            this.setCalendarRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.setCalendarRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.setCalendarRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.setCalendarRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.setCalendarRibbonButton_OnClick);
            // 
            // adxRibbonGroup4
            // 
            this.adxRibbonGroup4.Caption = "Reports";
            this.adxRibbonGroup4.Controls.Add(this.createReportRibbonButton);
            this.adxRibbonGroup4.Id = "adxRibbonGroup_e1d1192dcb9949d1a6bbc3f15a36b255";
            this.adxRibbonGroup4.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup4.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // createReportRibbonButton
            // 
            this.createReportRibbonButton.Caption = "Create Report";
            this.createReportRibbonButton.Id = "adxRibbonButton_05ba8353f95e47ef9e61252a34f599c9";
            this.createReportRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.createReportRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.createReportRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.createReportRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.createReportRibbonButton_OnClick);
            // 
            // adxRibbonGroup2
            // 
            this.adxRibbonGroup2.Caption = "View && Data";
            this.adxRibbonGroup2.Controls.Add(this.addViewRibbonButton);
            this.adxRibbonGroup2.Controls.Add(this.filterDataRibbonButton);
            this.adxRibbonGroup2.Id = "adxRibbonGroup_ac8b5157188940fa87ad6ce33aa4987a";
            this.adxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            // 
            // addViewRibbonButton
            // 
            this.addViewRibbonButton.Caption = "Add View";
            this.addViewRibbonButton.Id = "adxRibbonButton_872f732972e94bc4bc1221a565cadcc5";
            this.addViewRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.addViewRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.addViewRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.addViewRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.addViewRibbonButton_OnClick);
            // 
            // filterDataRibbonButton
            // 
            this.filterDataRibbonButton.Caption = "Filter Data";
            this.filterDataRibbonButton.Id = "adxRibbonButton_f72705aa9a1f423ca0b918764ed7cd50";
            this.filterDataRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.filterDataRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrProjectProject;
            this.filterDataRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.filterDataRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.filterDataRibbonButton_OnClick);
            // 
            // adxProjectEvents
            // 
            this.adxProjectEvents.ProjectBeforeResourceChange += new AddinExpress.MSO.ADXProjectBeforeChange_EventHandler(this.adxProjectEvents_ProjectBeforeResourceChange);
            // 
            // AddinModule
            // 
            this.AddinName = "ADXMSProject";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaProject;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        private int _newResourceId = 0;
        private int _newTaskId = 0;

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public MSProject._MSProject MSProjectApp
        {
            get
            {
                return (HostApplication as MSProject._MSProject);
            }
        }

        private void adxRibbonButton1_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            MSProject.Selection selection = null;
            MSProject.Tasks selectedTasks = null;
            MSProject.Resources selectedResources = null;
            MSProject.Task task = null;
            MSProject.Resource resource = null;
            string taskList = string.Empty;
            string resourceList = string.Empty;

            try
            {
                selection = MSProjectApp.ActiveSelection;
                selectedTasks = selection.Tasks;
                selectedResources = selection.Resources;

                if (selectedTasks != null)
                {
                    for (int t = 1; t <= selectedTasks.Count; t++)
                    {
                        task = selectedTasks[t];
                        int duration = Convert.ToInt32(task.Duration);
                        taskList += string.Format(
                            "{0}({1} hours){2}", 
                            task.Name, duration / 60, Environment.NewLine);
                        if (task != null) Marshal.ReleaseComObject(task);
                    }
                    MessageBox.Show(string.Format(
                        "{0} tasks selected: {1}{2}", 
                        selectedTasks.Count, Environment.NewLine, taskList));
                }

                if (selectedResources != null)
                {
                    for (int r = 1; r <= selectedResources.Count; r++)
                    {
                        resource = selectedResources[r];
                        resourceList += resource.Name + 
                            "(" + resource.StandardRate + ")" + Environment.NewLine;
                        if (resource != null) Marshal.ReleaseComObject(resource);
                    }
                    MessageBox.Show(string.Format(
                        "{0} resources selected: {1}{2}", 
                        selectedResources.Count, Environment.NewLine, resourceList));
                }
            }
            finally
            {
                if (selectedResources != null) Marshal.ReleaseComObject(selectedResources);
                if (selectedTasks != null) Marshal.ReleaseComObject(selectedTasks);
                if (selection != null) Marshal.ReleaseComObject(selection);
            }
        }

        private void adxProjectEvents_ProjectBeforeResourceChange(object sender, 
            ADXProjectBeforeChangeEventArgs e)
        {
            MSProject.Resource resource = e.Item as MSProject.Resource;

            if (resource != null)
                MessageBox.Show("You're changing " + resource.Name);
        }

        private void addResourceRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            MSProject.Project currProject = null;
            MSProject.Resources resources = null;
            MSProject.Resource resource = null;

            try
            {
                currProject = MSProjectApp.ActiveProject;
                resources = currProject.Resources;
                resource = resources.Add("A New Resource");
                _newResourceId = resource.UniqueID;
            }
            finally
            {
                if (resource != null) Marshal.ReleaseComObject(resource);
                if (resources != null) Marshal.ReleaseComObject(resources);
                if (currProject != null) Marshal.ReleaseComObject(currProject);
            }
        }

        private void editResourceRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProject.Project currProject = null;
            MSProject.Resources resources = null;
            MSProject.Resource resource = null;

            try
            {
                currProject = MSProjectApp.ActiveProject;
                resources = currProject.Resources;
                resource = resources.UniqueID[_newResourceId];
                if (resource != null)
                    resource.Name = "Updated New Resource";
            }
            finally
            {
                if (resource != null) Marshal.ReleaseComObject(resource);
                if (resources != null) Marshal.ReleaseComObject(resources);
                if (currProject != null) Marshal.ReleaseComObject(currProject);
            }
        }

        private void addSummaryTaskRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProject.Cell activeCell = null;
            MSProject.Task task = null;
            MSProject.Tasks subTasks = null;
            MSProject.Task subTask = null;

            try
            {
                MSProjectApp.InsertSummaryTask();
                activeCell = MSProjectApp.ActiveCell;
                task = activeCell.Task;
                task.Name = "Task Summary";
                subTasks = task.SuccessorTasks;
                subTask = subTasks.Add("New Sub Task");
                subTask.Resources.Add("Developer");
            }
            finally
            {
                if (activeCell != null) Marshal.ReleaseComObject(activeCell);
                if (subTask != null) Marshal.ReleaseComObject(subTask);
                if (subTasks != null) Marshal.ReleaseComObject(subTasks);
                if (task != null) Marshal.ReleaseComObject(task);
            }
        }

        private void addTaskRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProject.Project project = null;
            MSProject.Tasks tasks = null;
            MSProject.Task task = null;

            try
            {
                project = MSProjectApp.ActiveProject;
                tasks = project.Tasks;
                task = tasks.Add("My New Task");
                _newTaskId = task.UniqueID;
            }
            finally
            {
                if (task != null) Marshal.ReleaseComObject(task);
                if (tasks != null) Marshal.ReleaseComObject(tasks);
                if (project != null) Marshal.ReleaseComObject(project);
            }
        }

        private void editTaskRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProject.Project project = null;
            MSProject.Tasks tasks = null;
            MSProject.Task task = null;

            try
            {
                project = MSProjectApp.ActiveProject;
                tasks = project.Tasks;
                task = tasks.UniqueID[_newTaskId];
                if (task != null)
                {
                    task.Name = "Updated New Task";
                }
            }
            finally
            {
                if (task != null) Marshal.ReleaseComObject(task);
                if (tasks != null) Marshal.ReleaseComObject(tasks);
                if (project != null) Marshal.ReleaseComObject(project);
            }
        }

        private void setCalendarRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            MSProject.Project currProject = null;
            MSProject.Calendar calendar = null;
            MSProject.WeekDays weekDays = null;
            MSProject.WeekDay monday = null;
            MSProject.WeekDay tuesday = null;
            MSProject.WeekDay wednesday = null;
            MSProject.WeekDay thursday = null;
            MSProject.WeekDay friday = null;
            MSProject.Shift fridayShift1 = null;

            try
            {
                currProject = MSProjectApp.ActiveProject;
                calendar = currProject.Calendar;
                weekDays = calendar.WeekDays;

                monday = weekDays[MSProject.PjWeekday.pjMonday];
                monday.set_Working(false);

                tuesday = weekDays[MSProject.PjWeekday.pjTuesday];
                tuesday.set_Working(false);

                wednesday = weekDays[MSProject.PjWeekday.pjWednesday];
                wednesday.set_Working(true);

                thursday = weekDays[MSProject.PjWeekday.pjThursday];
                thursday.set_Working(true);

                friday = weekDays[MSProject.PjWeekday.pjFriday];
                friday.set_Working(true);

                fridayShift1 = friday.Shift1;
                fridayShift1.Start = new DateTime(2014, 02, 20, 10, 30, 0);
                fridayShift1.Finish = new DateTime(2014, 02, 20, 16, 00, 0);
            }
            finally
            {
                if (fridayShift1 != null) Marshal.ReleaseComObject(fridayShift1);
                if (friday != null) Marshal.ReleaseComObject(friday);
                if (thursday != null) Marshal.ReleaseComObject(thursday);
                if (wednesday != null) Marshal.ReleaseComObject(wednesday);
                if (tuesday != null) Marshal.ReleaseComObject(tuesday);
                if (monday != null) Marshal.ReleaseComObject(monday);
                if (weekDays != null) Marshal.ReleaseComObject(weekDays);
                if (calendar != null) Marshal.ReleaseComObject(calendar);
                if (currProject != null) Marshal.ReleaseComObject(currProject);
            }
        }

        private void applyReportRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            MSProjectApp.ApplyReport("Critical Tasks");
        }

        private void addViewRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProject.Project currProject = null;
            try
            {
                currProject = MSProjectApp.ActiveProject;
                MSProjectApp.ViewEditSingle(
                    "My New View", true, Type.Missing, 1, 
                    true, false, "Cost", "All Tasks", "Critical");
                MSProjectApp.ViewApplyEx(
                    "Gantt with Timeline", Type.Missing, Type.Missing, 0);
            }
            finally
            {
                if (currProject != null) Marshal.ReleaseComObject(currProject);
            }
        }

        private void filterDataRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProjectApp.FilterEdit(
                "My New Filter", true, true, true, Type.Missing, Type.Missing, 
                "Name", Type.Missing, "contains", "Develop", Type.Missing, true, true);
            MSProjectApp.FilterApply("My New Filter");
        }

        private void createReportRibbonButton_OnClick(object sender,
            IRibbonControl control, bool pressed)
        {
            MSProject.Project currProject = null;
            MSProject.Reports reports = null;
            MSProject.Report report = null;
            MSProject.Shapes shapes = null;
            MSProject.Shape shape = null;
            MSProject.ReportTable shapeTable = null;
            MSProject.PjField[] fields = null;

            try
            {
                currProject = MSProjectApp.ActiveProject;
                reports = currProject.Reports;

                report = reports.Add("My New Report");
                shapes = report.Shapes;
                shape = shapes.AddTable(3, 4, 20, 20, 200, 100);
                shapeTable = shape.Table;

                fields = new MSProject.PjField[] { 
                    MSProject.PjField.pjTaskName, MSProject.PjField.pjTaskDuration };
                shapeTable.UpdateTableData(true, "Critical", "Critical", -1, fields);
            }
            finally
            {
                if (shapeTable != null) Marshal.ReleaseComObject(shapeTable);
                if (shape != null) Marshal.ReleaseComObject(shape);
                if (shapes != null) Marshal.ReleaseComObject(shapes);
                if (report != null) Marshal.ReleaseComObject(report);
                if (reports != null) Marshal.ReleaseComObject(reports);
                if (currProject != null) Marshal.ReleaseComObject(currProject);
            }
        }
    }
}

